function get_archive_files_time_stamps, day1996, structToUse
    HEADER_LENGTH = 32

    structName = get_struct_name_from_struct(structToUse)
    date = get_date_from_day_1996(day1996)
    dataFilePath = generate_data_file_path(date, structName)

	; what if data file does not exist?
    if (file_exists(dataFilePath) EQ 0) then begin
	print, 'FLAG: ', dataFilePath, ' does not exist.  No data that day?'
	stampArray = lonarr(1)
	stampArray[0] = 0
	return, stampArray
    endif

    structsInFileCount = get_files_struct_count(dataFilePath, structToUse)

    get_lun, lun
    openr, lun, dataFilePath
    fileAssoc =								       $
	assoc(lun, replicate(structToUse, structsInFileCount), HEADER_LENGTH)
    structArray = fileAssoc(0)
    close, lun
    free_lun, lun

    return, get_time_stamps_of_structs(structArray)
end
