function get_first_date_of_archived_data, structName
    DIR_CHAR = '/'

    instrumentID = get_instrument_id_from_struct_name(structName)
    dataTypeSuffix = get_data_file_suffix_from_struct_name(structName)

    if (instrumentID EQ 'c') then					$
		baseDir = getenv('L1_CRIS_DATA_BASE_DIRECTORY')		$
    else baseDir = getenv('L1_SIS_DATA_BASE_DIRECTORY')

    baseDirParts = str_sep(baseDir, DIR_CHAR)
    for i = 0, n_elements(baseDirParts) - 1 do begin
	if (baseDirParts[i] EQ 'data') then begin
	    filePrefix = ''
	    for i = i + 1, n_elements(baseDirParts) - 1 do begin
		filePrefix = filePrefix + baseDirParts[i]
		if (i LT (n_elements(baseDirParts) - 1)) then		$
					filePrefix = filePrefix + '.'
	    endfor
	endif
    endfor

    pattern = baseDir
    res = findfile(pattern, count = COUNT)
    indicies = sort(res)
    for i = 0, n_elements(indicies) - 1 do begin
	pattern = pattern + DIR_CHAR + res[indicies[i]]
	res2 = findfile(pattern, count = COUNT)
	indicies2 = sort(res2)
	for j = 0, n_elements(indicies2) - 1 do begin
	    pattern = baseDir + DIR_CHAR + res[indicies[i]] +		$
		DIR_CHAR + res2[indicies2[j]] + DIR_CHAR +		$
		filePrefix + '.' + res2[indicies2[j]] + '.' + dataTypeSuffix
	    res3 = findfile(pattern, count = COUNT)
	    if (count EQ 1) then begin
		dateParts = str_sep(res2[indicies2[j]], '.')
		time = {AceTime}
		time.year = fix(dateParts[0])
		time.month = fix(dateParts[1])
		time.day = fix(dateParts[2])
		return, time
	    endif
	endfor
    endfor

    return, {AceTime}		; blank time struct
end
