#include <stdio.h>
#include <string.h>
#include "hdfi.h"
#include "cris.h"
#include "sis.h"

int getDataTypePeriodFromStructName(char *structName) {
    if (strstr(structName, "Cris") != NULL) {
	if (strcmp(structName, "BrowseCris") == 0)
	    return CRIS_BROWSE_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1CrisCommandEcho") == 0)
	    return CRIS_COMMAND_ECHO_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1CrisCommandTable") == 0)
	    return CRIS_COMMAND_TABLE_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1CrisDiagnosticEvent") == 0)
	    return CRIS_DIAGNOSTIC_EVENT_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1CrisEventCycle") == 0)
	    return CRIS_EVENT_CYCLE_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1CrisHighPriorityRate") == 0)
	    return CRIS_HIGH_PRIORITY_RATE_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1CrisHskp") == 0)
	    return CRIS_HOUSEKEEPING_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1CrisLowPriorityRate") == 0)
	    return CRIS_LOW_PRIORITY_RATE_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1CrisSubset") == 0)
	    return CRIS_SUBSET_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1CrisSummary") == 0)
	    return CRIS_SUMMARY_SAMPLE_PERIOD;
    }
    else {
	if (strcmp(structName, "BrowseSis") == 0)
	    return SIS_BROWSE_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1SisCommandEcho") == 0)
	    return SIS_COMMAND_ECHO_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1SisCommandTable") == 0)
	    return SIS_COMMAND_TABLE_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1SisDacOffset0") == 0)
	    return SIS_DAC_OFFSET_0_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1SisDacOffset1") == 0)
	    return SIS_DAC_OFFSET_1_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1SisDiagnosticEvent") == 0)
	    return SIS_DIAGNOSTIC_EVENT_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1SisEventCycle") == 0)
	    return SIS_EVENT_CYCLE_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1SisHighPriorityRate") == 0)
	    return SIS_HIGH_PRIORITY_RATE_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1SisHskp") == 0)
	    return SIS_HOUSEKEEPING_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1SisLowPriorityRate") == 0)
	    return SIS_LOW_PRIORITY_RATE_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1SisSubset") == 0)
	    return SIS_SUBSET_SAMPLE_PERIOD;
	else if (strcmp(structName, "L1SisSummary") == 0)
	    return SIS_SUMMARY_SAMPLE_PERIOD;
    }

	/* if we got here, did not recognize the structure name */
    fprintf(stderr, "getStructSizeFromName: ERROR\n");
    fprintf(stderr, "  Struct name ->%s<- not recognized.  Exiting.\n\n",
								structName);
    exit(0);
}
