#include <time.h>
#include "hdfi.h"
#include "crisSisGetUtilities.h"
#include "utilities.h"

	/* this routine returns an array of structs of data which are valid */
	/* at the start of day1996 (this means it will usually grab the */
	/* last struct in the previous day's archive file) up to the last */
	/* struct which is not valid at the next day's start second (this */
	/* means usually the final struct in day1996's archive file will */
	/* not be included in the returned array.) */

void *getDaysStructs(int day1996, char *structName) {
    struct tm *pTimeStruct;
    uint32 secondsSince1996Start, secondsSince1996Stop;

    pTimeStruct = getDateFromDay1996(day1996);
    secondsSince1996Start = getSecondsSince1996FromDate(pTimeStruct);
    secondsSince1996Stop = secondsSince1996Start + 86400L;
    return getStructs(secondsSince1996Start, secondsSince1996Stop, structName);
}
