#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "crisSisGetUtilities.h"
#include "utilities.h"

int getFilesStructCount(char *dataFilePath, int structSize, int hasHeader) {
    struct stat fileStats;
    unsigned int structCount;

    if (!fileExists(dataFilePath)) return 0;
    else if (stat(dataFilePath, &fileStats) == -1) {
	fprintf(stderr, "stat for %s failed.  Exiting.\n\n", dataFilePath);
	exit(0);
    }

    structCount = fileStats.st_size;
    if (hasHeader) structCount -= HEADER_BYTES;

    if (structCount % structSize) {
	fprintf(stderr, "non-integral number of structs calculated for %s\n",
								dataFilePath);
	fprintf(stderr, "Exiting.\n\n");
	exit(0);
    }

    structCount /= structSize;
    return structCount;
}
